C# Класс SolidworksAddinFramework.Geometry.CurveExtension

Показать файл Открыть проект

Открытые методы

Метод Описание
ApplyTransform ( this body, Matrix4x4 t ) : void
ClosestDistanceBetweenTwoCurves ( IMathUtility m, ICurve curve0, ICurve curve1 ) : EdgeDistance
ClosestPointOn ( this curve, System.Vector3 v ) : PointParam
ClosestPointOn ( this curve, double x, double y, double z ) : PointParam
ClosestPointTangentOn ( this curve, System.Vector3 v ) : PointDirection3
ClosestPointToRay ( this curve, PointDirection3 ray, double tol = 1e-9 ) : PointParamWithRayProjection
CreateTrimmedCurve ( this curve, double t0, double t1 ) : ICurve
CurveBoundsDoubleArray ( this curve ) : double[]
DisplayUndoable ( this curve, IModelDoc2 doc, Color color, double thickness, double chordTol = 1e-6, double lengthTol, int layer ) : IDisposable
DisplayUndoable ( this line, IModelDoc2 doc, Color color, double thickness = 1, int layer ) : IDisposable
Domain ( this curve ) : double[]

Return the domain of the curve. ie the [startParam, endParam]

EndPoint ( this curve, int derivatives ) : List
EndPoint ( this curve ) : System.Vector3
FindMinimumRadius ( this curve ) : MinimumRadiusResult
GetCurveTs ( this edge ) : ICurve
GetPlanePoints ( this curve, double position, System.Vector3 &pNormal, System.Vector3 &pCurve, System.Vector3 &pAxis ) : void
GetPointsByLength ( this curve, double pointDistance, DoubleRange flankHelixDomain = null ) : List

Approximation. Be carefull

GetTessPoints ( this curve, double chordTol, double lengthTol, RangeDouble domain = null ) : System.Vector3[]
Length ( this curve ) : double

Return the length of the curve between the start and end parameters.

PointAt ( this curve, double t, int derivatives ) : List

Return the point at parameter value t on the curve.

PointAt ( this curve, double t ) : System.Vector3
PointAtDistanceFrom ( this c, System.Vector3 p0, double distance ) : double
PointAtDistanceFrom ( this c, double t0, double distance ) : double

Should solve

PointParamAt ( this curve, double t ) : PointParam
PointTangentAt ( this c, double t ) : PointDirection3
ReverseEvaluate ( this curve, System.Vector3 p ) : double
StartPoint ( this curve, int derivatives ) : List
StartPoint ( this curve ) : System.Vector3

Приватные методы

Метод Описание
GetTessPotsAsVector3 ( ICurve curve, double chordTol, double lengthTol, double startPt, double midPt ) : IEnumerable
MakeEdge ( IList edge ) : Edge3

Описание методов

ApplyTransform() публичный статический Метод

public static ApplyTransform ( this body, Matrix4x4 t ) : void
body this
t Matrix4x4
Результат void

ClosestDistanceBetweenTwoCurves() публичный статический Метод

public static ClosestDistanceBetweenTwoCurves ( IMathUtility m, ICurve curve0, ICurve curve1 ) : EdgeDistance
m IMathUtility
curve0 ICurve
curve1 ICurve
Результат EdgeDistance

ClosestPointOn() публичный статический Метод

public static ClosestPointOn ( this curve, System.Vector3 v ) : PointParam
curve this
v System.Vector3
Результат PointParam

ClosestPointOn() публичный статический Метод

public static ClosestPointOn ( this curve, double x, double y, double z ) : PointParam
curve this
x double
y double
z double
Результат PointParam

ClosestPointTangentOn() публичный статический Метод

public static ClosestPointTangentOn ( this curve, System.Vector3 v ) : PointDirection3
curve this
v System.Vector3
Результат PointDirection3

ClosestPointToRay() публичный статический Метод

public static ClosestPointToRay ( this curve, PointDirection3 ray, double tol = 1e-9 ) : PointParamWithRayProjection
curve this
ray PointDirection3
tol double
Результат PointParamWithRayProjection

CreateTrimmedCurve() публичный статический Метод

public static CreateTrimmedCurve ( this curve, double t0, double t1 ) : ICurve
curve this
t0 double
t1 double
Результат ICurve

CurveBoundsDoubleArray() публичный статический Метод

public static CurveBoundsDoubleArray ( this curve ) : double[]
curve this
Результат double[]

DisplayUndoable() публичный статический Метод

public static DisplayUndoable ( this curve, IModelDoc2 doc, Color color, double thickness, double chordTol = 1e-6, double lengthTol, int layer ) : IDisposable
curve this
doc IModelDoc2
color Color
thickness double
chordTol double
lengthTol double
layer int
Результат IDisposable

DisplayUndoable() публичный статический Метод

public static DisplayUndoable ( this line, IModelDoc2 doc, Color color, double thickness = 1, int layer ) : IDisposable
line this
doc IModelDoc2
color Color
thickness double
layer int
Результат IDisposable

Domain() публичный статический Метод

Return the domain of the curve. ie the [startParam, endParam]
public static Domain ( this curve ) : double[]
curve this
Результат double[]

EndPoint() публичный статический Метод

public static EndPoint ( this curve, int derivatives ) : List
curve this
derivatives int
Результат List

EndPoint() публичный статический Метод

public static EndPoint ( this curve ) : System.Vector3
curve this
Результат System.Vector3

FindMinimumRadius() публичный статический Метод

public static FindMinimumRadius ( this curve ) : MinimumRadiusResult
curve this
Результат MinimumRadiusResult

GetCurveTs() публичный статический Метод

public static GetCurveTs ( this edge ) : ICurve
edge this
Результат ICurve

GetPlanePoints() публичный статический Метод

public static GetPlanePoints ( this curve, double position, System.Vector3 &pNormal, System.Vector3 &pCurve, System.Vector3 &pAxis ) : void
curve this
position double
pNormal System.Vector3
pCurve System.Vector3
pAxis System.Vector3
Результат void

GetPointsByLength() публичный статический Метод

Approximation. Be carefull
public static GetPointsByLength ( this curve, double pointDistance, DoubleRange flankHelixDomain = null ) : List
curve this
pointDistance double
flankHelixDomain AForge.DoubleRange
Результат List

GetTessPoints() публичный статический Метод

public static GetTessPoints ( this curve, double chordTol, double lengthTol, RangeDouble domain = null ) : System.Vector3[]
curve this
chordTol double
lengthTol double
domain RangeDouble
Результат System.Vector3[]

Length() публичный статический Метод

Return the length of the curve between the start and end parameters.
public static Length ( this curve ) : double
curve this
Результат double

PointAt() публичный статический Метод

Return the point at parameter value t on the curve.
public static PointAt ( this curve, double t, int derivatives ) : List
curve this
t double
derivatives int
Результат List

PointAt() публичный статический Метод

public static PointAt ( this curve, double t ) : System.Vector3
curve this
t double
Результат System.Vector3

PointAtDistanceFrom() публичный статический Метод

public static PointAtDistanceFrom ( this c, System.Vector3 p0, double distance ) : double
c this
p0 System.Vector3
distance double
Результат double

PointAtDistanceFrom() публичный статический Метод

Should solve
public static PointAtDistanceFrom ( this c, double t0, double distance ) : double
c this
t0 double
distance double
Результат double

PointParamAt() публичный статический Метод

public static PointParamAt ( this curve, double t ) : PointParam
curve this
t double
Результат PointParam

PointTangentAt() публичный статический Метод

public static PointTangentAt ( this c, double t ) : PointDirection3
c this
t double
Результат PointDirection3

ReverseEvaluate() публичный статический Метод

public static ReverseEvaluate ( this curve, System.Vector3 p ) : double
curve this
p System.Vector3
Результат double

StartPoint() публичный статический Метод

public static StartPoint ( this curve, int derivatives ) : List
curve this
derivatives int
Результат List

StartPoint() публичный статический Метод

public static StartPoint ( this curve ) : System.Vector3
curve this
Результат System.Vector3